Index: pjproject/trunk/pjmedia/build/pjmedia.dsp
===================================================================
--- pjproject/trunk/pjmedia/build/pjmedia.dsp	(revision 120)
+++ pjproject/trunk/pjmedia/build/pjmedia.dsp	(revision 121)
@@ -33,14 +33,14 @@
 # PROP BASE Use_MFC 0
 # PROP BASE Use_Debug_Libraries 0
-# PROP BASE Output_Dir ".\output\pjmedia_vc6_Release"
-# PROP BASE Intermediate_Dir ".\output\pjmedia_vc6_Release"
+# PROP BASE Output_Dir ".\output\pjmedia_i386_win32_vc6_release"
+# PROP BASE Intermediate_Dir ".\output\pjmedia_i386_win32_vc6_release"
 # PROP BASE Target_Dir ""
 # PROP Use_MFC 0
 # PROP Use_Debug_Libraries 0
-# PROP Output_Dir ".\output\pjmedia_vc6_Release"
-# PROP Intermediate_Dir ".\output\pjmedia_vc6_Release"
+# PROP Output_Dir ".\output\pjmedia_i386_win32_vc6_release"
+# PROP Intermediate_Dir ".\output\pjmedia_i386_win32_vc6_release"
 # PROP Target_Dir ""
 # ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_MBCS" /D "_LIB" /YX /FD /c
-# ADD CPP /nologo /MD /W4 /GX /O2 /I "../../pjlib/src" /I "../src" /I "../../pjsdp/src" /I "../src/pjmedia/portaudio" /D "NDEBUG" /D "PA_NO_ASIO" /D "WIN32" /D "_MBCS" /D "_LIB" /FD /c
+# ADD CPP /nologo /MD /W4 /GX /O2 /I "../include" /I "../../pjlib/include" /I "../../pjlib-util/include" /I "../src/pjmedia/portaudio" /D "NDEBUG" /D "PA_NO_ASIO" /D "WIN32" /D "_MBCS" /D "_LIB" /D PJ_WIN32=1 /D PJ_M_I386=1 /FD /c
 # SUBTRACT CPP /YX
 # ADD BASE RSC /l 0x409 /d "NDEBUG"
@@ -57,14 +57,14 @@
 # PROP BASE Use_MFC 0
 # PROP BASE Use_Debug_Libraries 1
-# PROP BASE Output_Dir ".\output\pjmedia_vc6_Debug"
-# PROP BASE Intermediate_Dir ".\output\pjmedia_vc6_Debug"
+# PROP BASE Output_Dir ".\output\pjmedia_i386_win32_vc6_debug"
+# PROP BASE Intermediate_Dir ".\output\pjmedia_i386_win32_vc6_debug"
 # PROP BASE Target_Dir ""
 # PROP Use_MFC 0
 # PROP Use_Debug_Libraries 1
-# PROP Output_Dir ".\output\pjmedia_vc6_Debug"
-# PROP Intermediate_Dir ".\output\pjmedia_vc6_Debug"
+# PROP Output_Dir ".\output\pjmedia_i386_win32_vc6_debug"
+# PROP Intermediate_Dir ".\output\pjmedia_i386_win32_vc6_debug"
 # PROP Target_Dir ""
 # ADD BASE CPP /nologo /W3 /Gm /GX /ZI /Od /D "WIN32" /D "_DEBUG" /D "_MBCS" /D "_LIB" /YX /FD /GZ /c
-# ADD CPP /nologo /MTd /W4 /Gm /GX /ZI /Od /I "../../pjlib/src" /I "../src" /I "../../pjsdp/src" /I "../src/pjmedia/portaudio" /D "_DEBUG" /D "PA_NO_ASIO" /D "WIN32" /D "_MBCS" /D "_LIB" /FR /FD /GZ /c
+# ADD CPP /nologo /MTd /W4 /Gm /GX /ZI /Od /I "../include" /I "../../pjlib/include" /I "../../pjlib-util/include" /I "../src/pjmedia/portaudio" /D "_DEBUG" /D "PA_NO_ASIO" /D "WIN32" /D "_MBCS" /D "_LIB" /D PJ_WIN32=1 /D PJ_M_I386=1 /FR /FD /GZ /c
 # SUBTRACT CPP /YX
 # ADD BASE RSC /l 0x409 /d "_DEBUG"
@@ -142,45 +142,45 @@
 # Begin Source File
 
-SOURCE=..\src\pjmedia\codec.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjmedia\config.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjmedia\jbuf.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjmedia\mediamgr.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjmedia.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjmedia\rtcp.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjmedia\rtp.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjmedia\sdp.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjmedia\session.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjmedia\sound.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjmedia\stream.h
+SOURCE=..\include\pjmedia\codec.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjmedia\config.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjmedia\jbuf.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjmedia\mediamgr.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjmedia.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjmedia\rtcp.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjmedia\rtp.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjmedia\sdp.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjmedia\session.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjmedia\sound.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjmedia\stream.h
 # End Source File
 # End Group
Index: pjproject/trunk/pjmedia/build/pjmedia.dsw
===================================================================
--- pjproject/trunk/pjmedia/build/pjmedia.dsw	(revision 120)
+++ pjproject/trunk/pjmedia/build/pjmedia.dsw	(revision 121)
@@ -4,12 +4,8 @@
 ###############################################################################
 
-Project: "pjaudio_tool"=.\pjaudio_tool.dsp - Package Owner=<4>
+Project: "pjaut"=.\pjaut.dsp - Package Owner=<4>
 
 Package=<5>
 {{{
-    begin source code control
-    "$/pjproject/pjmedia/build", TKAAAAAA
-    .
-    end source code control
 }}}
 
@@ -30,8 +26,16 @@
 Package=<5>
 {{{
-    begin source code control
-    "$/pjproject/pjmedia/build", TKAAAAAA
-    .
-    end source code control
+}}}
+
+Package=<4>
+{{{
+}}}
+
+###############################################################################
+
+Project: "pjlib_util"="..\..\pjlib-util\build\pjlib_util.dsp" - Package Owner=<4>
+
+Package=<5>
+{{{
 }}}
 
@@ -46,8 +50,4 @@
 Package=<5>
 {{{
-    begin source code control
-    "$/pjproject/pjmedia/build", TKAAAAAA
-    .
-    end source code control
 }}}
 
@@ -65,8 +65,4 @@
 Package=<5>
 {{{
-    begin source code control
-    "$/pjproject/pjmedia/build", TKAAAAAA
-    .
-    end source code control
 }}}
 
@@ -90,8 +86,4 @@
 Package=<5>
 {{{
-    begin source code control
-    "$/pjproject/pjmedia/build", TKAAAAAA
-    .
-    end source code control
 }}}
 
Index: pjproject/trunk/pjmedia/include/pjmedia.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia.h	(revision 121)
+++ pjproject/trunk/pjmedia/include/pjmedia.h	(revision 121)
@@ -0,0 +1,32 @@
+/* $Id$ */
+/* 
+ * Copyright (C) 2003-2006 Benny Prijono <benny@prijono.org>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+#ifndef __PJMEDIA_H__
+#define __PJMEDIA_H__
+
+#include <pjmedia/codec.h>
+#include <pjmedia/jbuf.h>
+#include <pjmedia/mediamgr.h>
+#include <pjmedia/rtcp.h>
+#include <pjmedia/rtp.h>
+#include <pjmedia/session.h>
+#include <pjmedia/sound.h>
+#include <pjmedia/sdp.h>
+
+#endif	/* __PJMEDIA_H__ */
+
Index: pjproject/trunk/pjmedia/include/pjmedia/codec.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia/codec.h	(revision 121)
+++ pjproject/trunk/pjmedia/include/pjmedia/codec.h	(revision 121)
@@ -0,0 +1,353 @@
+/* $Id$ */
+/* 
+ * Copyright (C) 2003-2006 Benny Prijono <benny@prijono.org>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+#ifndef __PJMEDIA_CODEC_H__
+#define __PJMEDIA_CODEC_H__
+
+
+/**
+ * @file codec.h
+ * @brief Codec framework.
+ */
+
+#include <pj/list.h>
+
+PJ_BEGIN_DECL
+
+
+/**
+ * @defgroup PJMED_CODEC Codec framework.
+ * @ingroup PJMEDIA
+ * @{
+ */
+
+/** Top most media type. */
+typedef enum pj_media_type
+{
+    /** No type. */
+    PJ_MEDIA_TYPE_NONE = 0,
+
+    /** The media is audio */
+    PJ_MEDIA_TYPE_AUDIO = 1,
+
+    /** The media is video. */
+    PJ_MEDIA_TYPE_VIDEO = 2,
+
+    /** Unknown media type, in this case the name will be specified in 
+     *  encoding_name.
+     */
+    PJ_MEDIA_TYPE_UNKNOWN = 3,
+
+} pj_media_type;
+
+
+/** Media direction. */
+typedef enum pj_media_dir_t
+{
+    /** None */
+    PJ_MEDIA_DIR_NONE = 0,
+
+    /** Encoding (outgoing to network) stream */
+    PJ_MEDIA_DIR_ENCODING = 1,
+
+    /** Decoding (incoming from network) stream. */
+    PJ_MEDIA_DIR_DECODING = 2,
+
+    /** Incoming and outgoing stream. */
+    PJ_MEDIA_DIR_ENCODING_DECODING = 3,
+
+} pj_media_dir_t;
+
+
+/** Standard RTP paylist types. */
+typedef enum pj_rtp_pt
+{
+    PJ_RTP_PT_PCMU = 0,		/* audio PCMU */
+    PJ_RTP_PT_GSM  = 3,		/* audio GSM */
+    PJ_RTP_PT_G723 = 4,		/* audio G723 */
+    PJ_RTP_PT_DVI4_8K = 5,	/* audio DVI4 8KHz */
+    PJ_RTP_PT_DVI4_16K = 6,	/* audio DVI4 16Khz */
+    PJ_RTP_PT_LPC = 7,		/* audio LPC */
+    PJ_RTP_PT_PCMA = 8,		/* audio PCMA */
+    PJ_RTP_PT_G722 = 9,		/* audio G722 */
+    PJ_RTP_PT_L16_2 = 10,	/* audio 16bit linear 44.1KHz stereo */
+    PJ_RTP_PT_L16_1 = 11,	/* audio 16bit linear 44.1KHz mono */
+    PJ_RTP_PT_QCELP = 12,	/* audio QCELP */
+    PJ_RTP_PT_CN = 13,		/* audio Comfort Noise */
+    PJ_RTP_PT_MPA = 14,		/* audio MPEG1 or MPEG2 as elementary streams */
+    PJ_RTP_PT_G728 = 15,	/* audio G728 */
+    PJ_RTP_PT_DVI4_11K = 16,	/* audio DVI4 11.025KHz mono */
+    PJ_RTP_PT_DVI4_22K = 17,	/* audio DVI4 22.050KHz mono */
+    PJ_RTP_PT_G729 = 18,	/* audio G729 */
+    PJ_RTP_PT_CELB = 25,	/* video/comb Cell-B by Sun Microsystems (RFC 2029) */
+    PJ_RTP_PT_JPEG = 26,	/* video JPEG */
+    PJ_RTP_PT_NV = 28,		/* video NV implemented by nv program by Xerox */
+    PJ_RTP_PT_H261 = 31,	/* video H261 */
+    PJ_RTP_PT_MPV = 32,		/* video MPEG1 or MPEG2 elementary streams */
+    PJ_RTP_PT_MP2T = 33,	/* video MPEG2 transport */
+    PJ_RTP_PT_H263 = 34,	/* video H263 */
+
+    PJ_RTP_PT_DYNAMIC = 96,	/* start of dynamic RTP payload */
+} pj_rtp_pt;
+
+
+/** Identification used to search for codec factory that supports specific 
+ *  codec specification. 
+ */
+typedef struct pj_codec_id
+{
+    /** Media type. */
+    pj_media_type   type;
+
+    /** Payload type (can be dynamic). */
+    unsigned	    pt;
+
+    /** Encoding name, must be present if the payload type is dynamic. */
+    pj_str_t	    encoding_name;
+
+    /** Sampling rate. */
+    unsigned	    sample_rate;
+} pj_codec_id;
+
+
+/** Detailed codec attributes used both to configure a codec and to query
+ *  the capability of codec factories.
+ */
+typedef struct pj_codec_attr
+{
+    pj_uint32_t	sample_rate;	    /* Sampling rate in Hz */
+    pj_uint32_t	avg_bps;	    /* Average bandwidth in bits per second */
+
+    pj_uint8_t	pcm_bits_per_sample;/* Bits per sample in the PCM side */
+    pj_uint16_t	ptime;		    /* Packet time in miliseconds */
+
+    unsigned	pt:8;		    /* Payload type. */
+    unsigned    vad_enabled:1;	    /* Voice Activity Detector. */
+    unsigned    cng_enabled:1;	    /* Comfort Noise Generator. */
+    unsigned    lpf_enabled:1;	    /* Low pass filter */
+    unsigned    hpf_enabled:1;	    /* High pass filter */
+    unsigned    penh_enabled:1;	    /* Perceptual Enhancement */
+    unsigned    concl_enabled:1;    /* Packet loss concealment */
+    unsigned    reserved_bit:1;
+
+} pj_codec_attr;
+
+/** Types of audio frame. */
+typedef enum pj_audio_frame_type
+{
+    /** The frame is a silence audio frame. */
+    PJ_AUDIO_FRAME_SILENCE,
+
+    /** The frame is a non-silence audio frame. */
+    PJ_AUDIO_FRAME_AUDIO,
+
+} pj_audio_frame_type;
+
+typedef struct pj_codec pj_codec;
+typedef struct pj_codec_factory pj_codec_factory;
+
+
+/** This structure describes an audio frame. */
+struct pj_audio_frame
+{
+    /** Type: silence or non-silence. */
+    pj_audio_frame_type type;
+
+    /** Pointer to buffer. */
+    void	*buf;
+
+    /** Frame size in bytes. */
+    unsigned	 size;
+};
+
+/**
+ * Operations that must be supported by the codec.
+ */
+typedef struct pj_codec_op
+{
+    /** Get default attributes. */
+    pj_status_t (*default_attr) (pj_codec *codec, pj_codec_attr *attr);
+
+    /** Open and initialize codec using the specified attribute.
+     *  @return zero on success.
+     */
+    pj_status_t	(*init)( pj_codec *codec, pj_pool_t *pool );
+
+    /** Close and shutdown codec.
+     */
+    pj_status_t	(*open)( pj_codec *codec, pj_codec_attr *attr );
+
+    /** Close and shutdown codec.
+     */
+    pj_status_t (*close)( pj_codec *codec );
+
+    /** Encode frame.
+     */
+    pj_status_t (*encode)( pj_codec *codec, const struct pj_audio_frame *input,
+			   unsigned output_buf_len, struct pj_audio_frame *output);
+
+    /** Decode frame.
+     */
+    pj_status_t (*decode)( pj_codec *codec, const struct pj_audio_frame *input,
+			   unsigned output_buf_len, struct pj_audio_frame *output);
+
+} pj_codec_op;
+
+/**
+ * A codec describes an instance to encode or decode media frames. 
+ */
+struct pj_codec
+{
+    /** Entries to put this codec instance in codec factory's list. */
+    PJ_DECL_LIST_MEMBER(struct pj_codec);
+
+    /** Codec's private data. */
+    void	*codec_data;
+
+    /** Codec factory where this codec was allocated. */
+    pj_codec_factory *factory;
+
+    /** Operations to codec. */
+    pj_codec_op	*op;
+};
+
+/**
+ * This structure describes operations that must be supported by codec factories.
+ */
+typedef struct pj_codec_factory_op
+{
+    /** Check whether the factory can create codec with the specified ID.
+     *  @param factory The codec factory.
+     *  @param id  The codec ID.
+     *  @return zero it matches.
+     */
+    pj_status_t	(*match_id)( pj_codec_factory *factory, const pj_codec_id *id );
+
+    /** Create default attributes for the specified codec ID. This function can
+     *  be called by application to get the capability of the codec.
+     *  @param factory The codec factory.
+     *  @param id  The codec ID.
+     *  @param attr The attribute to be initialized.
+     *  @return zero if success.
+     */
+    pj_status_t (*default_attr)( pj_codec_factory *factory, const pj_codec_id *id,
+				 pj_codec_attr *attr );
+
+    /** Enumerate supported codecs.
+     *  @param factory The codec factory.
+     *  @param count Number of entries in the array.
+     *  @param codecs The codec array.
+     *  @return the total number of supported codecs, which can be less or 
+     *          greater than requested.
+     */
+    unsigned (*enum_codecs) (pj_codec_factory *factory, unsigned count, pj_codec_id codecs[]);
+
+    /** This function is called by codec manager to instantiate one codec
+     *  instance.
+     *  @param factory The codec factory.
+     *  @param id  The codec ID.
+     *  @return the instance of the codec, or NULL if codec can not be created.
+     */
+    pj_codec* (*alloc_codec)( pj_codec_factory *factory, const pj_codec_id *id);
+
+    /** This function is called by codec manager to return a particular instance
+     *  of codec back to the codec factory.
+     *  @param factory The codec factory.
+     *  @param codec The codec instance to be returned.
+     */
+    void (*dealloc_codec)( pj_codec_factory *factory, pj_codec *codec );
+
+} pj_codec_factory_op;
+
+/**
+ * Codec factory describes a module that is able to create codec with specific
+ * capabilities. These capabilities can be queried by codec manager to create
+ * instances of codec.
+ */
+struct pj_codec_factory
+{
+    /** Entries to put this structure in the codec manager list. */
+    PJ_DECL_LIST_MEMBER(struct pj_codec_factory);
+
+    /** The factory's private data. */
+    void		*factory_data;
+
+    /** Operations to the factory. */
+    pj_codec_factory_op *op;
+
+};
+
+/**
+ * Declare maximum codecs
+ */
+#define PJ_CODEC_MGR_MAX_CODECS	    32
+
+/**
+ * Codec manager maintains codec factory etc.
+ */
+typedef struct pj_codec_mgr
+{
+    pj_codec_factory factory_list;
+    unsigned	     codec_cnt;
+    pj_codec_id	     codecs[PJ_CODEC_MGR_MAX_CODECS];
+} pj_codec_mgr;
+
+/**
+ * Init codec manager.
+ */
+PJ_DECL(pj_status_t) 
+pj_codec_mgr_init (pj_codec_mgr *mgr);
+
+/** 
+ * Register codec to codec manager. 
+ */
+PJ_DECL(pj_status_t) 
+pj_codec_mgr_register_factory (pj_codec_mgr *mgr, pj_codec_factory *factory);
+
+/**
+ * Unregister codec.
+ */
+PJ_DECL(void) 
+pj_codec_mgr_unregister_factory (pj_codec_mgr *mgr, pj_codec_factory *factory);
+
+/**
+ * Enumerate codecs.
+ */
+PJ_DECL(unsigned)
+pj_codec_mgr_enum_codecs (pj_codec_mgr *mgr, unsigned count, const pj_codec_id *codecs[]);
+
+/**
+ * Open codec.
+ */
+PJ_DECL(pj_codec*) 
+pj_codec_mgr_alloc_codec (pj_codec_mgr *mgr, const struct pj_codec_id *id);
+
+/**
+ * Close codec.
+ */
+PJ_DECL(void) 
+pj_codec_mgr_dealloc_codec (pj_codec_mgr *mgr, pj_codec *codec);
+
+/**
+ * @}
+ */
+
+PJ_END_DECL
+
+
+#endif	/* __PJMEDIA_CODEC_H__ */
Index: pjproject/trunk/pjmedia/include/pjmedia/config.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia/config.h	(revision 121)
+++ pjproject/trunk/pjmedia/include/pjmedia/config.h	(revision 121)
@@ -0,0 +1,27 @@
+/* $Id$ */
+/* 
+ * Copyright (C) 2003-2006 Benny Prijono <benny@prijono.org>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+#ifndef __PJMED_CONFIG_H__
+#define __PJMED_CONFIG_H__
+
+/**
+ * @defgroup PJMEDIA Media Stack
+ */
+
+
+#endif	/* __PJMED_CONFIG_H__ */
Index: pjproject/trunk/pjmedia/include/pjmedia/jbuf.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia/jbuf.h	(revision 121)
+++ pjproject/trunk/pjmedia/include/pjmedia/jbuf.h	(revision 121)
@@ -0,0 +1,142 @@
+/* $Id$ */
+/* 
+ * Copyright (C) 2003-2006 Benny Prijono <benny@prijono.org>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+#ifndef __PJMEDIA_JBUF_H__
+#define __PJMEDIA_JBUF_H__
+
+
+/**
+ * @file jbuf.h
+ * @brief Adaptive jitter buffer implementation.
+ */
+/**
+ * @defgroup PJMED_JBUF Adaptive jitter buffer
+ * @ingroup PJMEDIA
+ * @{
+ */
+
+#include <pj/types.h>
+
+
+PJ_BEGIN_DECL
+
+
+/**
+ * Opaque declaration of internal frame type used by jitter buffer. 
+ */
+struct pj_jbframe;
+
+
+/**
+ * Miscelaneous operation result/status. 
+ */ 
+typedef enum jb_op_status
+{
+    PJ_JB_STATUS_TOO_OLD = -2,		/** The packet is too old. */
+    PJ_JB_STATUS_TOO_SOON = -3,		/** The packet is too soon. */
+    PJ_JB_STATUS_FRAME_NULL = -4,	/** No packet can be retrieved */
+    PJ_JB_STATUS_FRAME_MISSING = -5,	/** The specified packet is missing/lost */
+} jb_op_status;
+
+
+/*
+ * Frame list, container abstraction for ordered list with fixed maximum
+ * size. It is used internally by the jitter buffer.
+ */  
+typedef struct pj_jbframelist
+{
+    unsigned		head, count, maxcount;
+    struct pj_jbframe  *frames;
+} pj_jbframelist;
+
+
+/**
+ * Jitter buffer implementation.
+ */ 
+typedef struct pj_jitter_buffer
+{
+    pj_jbframelist  lst;	    /** The frame list. */
+    int		    level;	    /** Current, real-time jitter level. */
+    int		    max_level;	    /** Maximum level for the period.	 */
+    unsigned	    prefetch;	    /** Prefetch count currently used. */
+    unsigned	    get_cnt;	    /** Number of get operation during prefetch state. */
+    unsigned	    min;	    /** Minimum jitter size, in packets. */
+    unsigned	    max;	    /** Maximum jitter size, in packets. */
+    pj_uint32_t	    lastseq;	    /** Last sequence number put to jitter buffer. */
+    unsigned	    upd_count;	    /** Internal counter to manage update interval. */
+    int		    state;	    /** Jitter buffer state (1==operational) */
+    int		    last_op;	    /** Last jitter buffer operation. */
+} pj_jitter_buffer;
+
+
+/**
+ * Initialize jitter buffer with the specified parameters.
+ * This function will allocate internal frame buffer from the specified pool.
+ * @param jb The jitter buffer to be initialized.
+ * @param pool Pool where memory will be allocated for the frame buffer.
+ * @param min The minimum value of jitter buffer, in packets.
+ * @param max The maximum value of jitter buffer, in packets.
+ * @param maxcount The maximum number of delay, in packets, which must be
+ *		   greater than max.
+ * @return PJ_SUCCESS on success.
+ */
+PJ_DECL(pj_status_t) pj_jb_init(pj_jitter_buffer *jb, pj_pool_t *pool, 
+				unsigned min, unsigned max, unsigned maxcount);
+
+/**
+ * Reset jitter buffer according to the parameters specified when the jitter
+ * buffer was initialized. Any packets currently in the buffer will be 
+ * discarded.
+ */
+PJ_DECL(void) pj_jb_reset(pj_jitter_buffer *jb);
+
+/**
+ * Put a pointer to the buffer with the specified sequence number. The pointer
+ * normally points to a buffer held by application, and this pointer will be
+ * returned later on when pj_jb_get() is called. The jitter buffer will not try
+ * to interpret the content of this pointer.
+ * @return:
+ *   - PJ_SUCCESS on success.
+ *   - PJ_JB_STATUS_TOO_OLD when the packet is too old.
+ *   - PJ_JB_STATUS_TOO_SOON when the packet is too soon.
+ */
+PJ_DECL(pj_status_t) pj_jb_put( pj_jitter_buffer *jb, pj_uint32_t extseq, void *buf );
+
+/**
+ * Get the earliest data from the jitter buffer. ONLY when the operation succeeds,
+ * the function returns both sequence number and a pointer in the parameters.
+ * This returned data corresponds to sequence number and pointer that were
+ * given to jitter buffer in the previous pj_jb_put operation.
+ * @return 
+ *  - PJ_SUCCESS on success
+ *  - PJ_JB_STATUS_FRAME_NULL when there is no frames to be returned.
+ *  - PJ_JB_STATUS_FRAME_MISSING if the jitter buffer detects that the packet 
+ *     is lost. Application may run packet concealment algorithm when it 
+ *     receives this status.
+ */
+PJ_DECL(pj_status_t) pj_jb_get( pj_jitter_buffer *jb, pj_uint32_t *extseq, void **buf );
+
+
+
+PJ_END_DECL
+
+/**
+ * @}
+ */
+
+#endif	/* __PJMEDIA_JBUF_H__ */
Index: pjproject/trunk/pjmedia/include/pjmedia/mediamgr.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia/mediamgr.h	(revision 121)
+++ pjproject/trunk/pjmedia/include/pjmedia/mediamgr.h	(revision 121)
@@ -0,0 +1,100 @@
+/* $Id$ */
+/* 
+ * Copyright (C) 2003-2006 Benny Prijono <benny@prijono.org>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+#ifndef __PJMEDIA_MEDIAMGR_H__
+#define __PJMEDIA_MEDIAMGR_H__
+
+
+/**
+ * @file mediamgr.h
+ * @brief Media Manager.
+ */
+/**
+ * @defgroup PJMED_MGR Media Manager
+ * @ingroup PJMEDIA
+ * @{
+ *
+ * The media manager acts as placeholder for endpoint capabilities. Each 
+ * media manager will have a codec manager to manage list of codecs installed
+ * in the endpoint and a sound device factory.
+ *
+ * A reference to media manager instance is required when application wants
+ * to create a media session (#pj_media_session_create or 
+ * #pj_media_session_create_from_sdp).
+ */
+
+#include <pjmedia/sound.h>
+#include <pjmedia/codec.h>
+
+
+PJ_BEGIN_DECL
+
+
+/** Opague declaration of media manager. */
+typedef struct pj_med_mgr_t pj_med_mgr_t;
+
+/**
+ * Create an instance of media manager.
+ *
+ * @param pf		Pool factory.
+ * @param conn_addr	Connection address to be used by this media manager.
+ *
+ * @return A new instance of media manager, or NULL if failed.
+ */
+PJ_DECL(pj_med_mgr_t*) pj_med_mgr_create (pj_pool_factory *pf);
+
+/**
+ * Destroy media manager instance.
+ *
+ * @param mgr		Media manager instance.
+ *
+ * @return zero on success.
+ */
+PJ_DECL(pj_status_t) pj_med_mgr_destroy (pj_med_mgr_t *mgr);
+
+/**
+ * Get pool factory of the media manager as specified when the media
+ * manager was created.
+ *
+ * @param mgr		The media manager instance.
+ *
+ * @return Pool factory instance of the media manager.
+ */
+PJ_DECL(pj_pool_factory*) pj_med_mgr_get_pool_factory (pj_med_mgr_t *mgr);
+
+/**
+ * Get the codec manager instance.
+ *
+ * @param mgr		The media manager instance.
+ *
+ * @return The instance of codec manager.
+ */
+PJ_DECL(pj_codec_mgr*) pj_med_mgr_get_codec_mgr (pj_med_mgr_t *mgr);
+
+
+
+PJ_END_DECL
+
+
+/**
+ * @}
+ */
+
+
+
+#endif	/* __PJMEDIA_MEDIAMGR_H__ */
